<?php
/**
* KeyCAPTCHA Plugin for Joomla 2.5.x
* @version $Id: keycaptcha.php 2012-03-13 $
* @package: KeyCAPTCHA
* ===================================================
* @author
* Name: Mersane, Ltd, www.keycaptcha.com
* Email: support@keycaptcha.com
* Url: https://www.keycaptcha.com
* ===================================================
* @copyright (C) 2011 Mersane, Ltd (www.keycaptcha.com). All rights reserved.
* @license GNU GPL 2.0 (http://www.gnu.org/licenses/gpl-2.0.html)
**/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

defined('_JEXEC') or die();
jimport('joomla.html.parameter');

if ( !class_exists('KeyCAPTCHA_CLASS') ) {
	class KeyCAPTCHA_CLASS
	{
		var $c_kc_keyword = "accept";
		var $p_kc_visitor_ip;
		var $p_kc_session_id;
		var $p_kc_web_server_sign;
		var $p_kc_web_server_sign2;
		var $p_kc_js_code;
		var $p_kc_private_key;
		var $p_kc_userID;

		function get_web_server_sign($use_visitor_ip = 0)
		{
			return md5($this->p_kc_session_id . (($use_visitor_ip) ? ($this->p_kc_visitor_ip) :("")) . $this->p_kc_private_key);
		}

		function KeyCAPTCHA_CLASS($a_private_key='', $buttonIDs='')
		{
			if ( $a_private_key != '' )	{
				$set = explode("0",trim($a_private_key),2);
				if (sizeof($set)>1){
					$this->p_kc_private_key = trim($set[0]);
					$this->p_kc_userID = (int)$set[1];
					$this->p_kc_js_code = 
"<!-- KeyCAPTCHA code (www.keycaptcha.com)-->
<script type=\"text/javascript\">
	var s_s_c_user_id = '".$this->p_kc_userID."';
	var s_s_c_session_id = '#KC_SESSION_ID#';
	var s_s_c_captcha_field_id = 'capcode';
	var s_s_c_submit_button_id = '".$buttonIDs."';
	var s_s_c_web_server_sign = '#KC_WSIGN#';
	var s_s_c_web_server_sign2 = '#KC_WSIGN2#';
</script>
<script type=\"text/javascript\" src=\"http://backs.keycaptcha.com/swfs/cap.js\"></script>
<!-- end of KeyCAPTCHA code-->";
				}
			}

			$this->p_kc_session_id = uniqid() . '-5.0.9.35';
			$this->p_kc_visitor_ip = $_SERVER["REMOTE_ADDR"];
			$this->p_kc_web_server_sign = "";
			$this->p_kc_web_server_sign2 = "";
		}

		function http_get($path)
		{
			$arr = parse_url($path);
			$host = $arr['host'];
			$page = $arr['path'];
			if ( $page=='' ) {
				$page='/';
			}
			if ( isset( $arr['query'] ) ) {
				$page.='?'.$arr['query'];
			}
			$errno = 0;
			$errstr = '';
			$fp = fsockopen ($host, 80, $errno, $errstr, 30);
			if (!$fp){ return ""; }
			$request = "GET $page HTTP/1.0\r\n";
			$request .= "Host: $host\r\n";
			$request .= "Connection: close\r\n";
			$request .= "Cache-Control: no-store, no-cache\r\n";
			$request .= "Pragma: no-cache\r\n";
			$request .= "User-Agent: KeyCAPTCHA\r\n";
			$request .= "\r\n";

			fwrite ($fp,$request);
			$out = '';

			while (!feof($fp)) $out .= fgets($fp, 250);
			fclose($fp);
			$ov = explode("close\r\n\r\n", $out);

			return $ov[1];
		}

		function check_result($response)
		{
			$kc_vars = explode("|", $response);
			if ( count( $kc_vars ) < 4 )
			{
				return false;
			}
			if ($kc_vars[0] == md5($this->c_kc_keyword . $kc_vars[1] . $this->p_kc_private_key . $kc_vars[2]))
			{
				if (strpos(strtolower($kc_vars[2]), "http://") !== 0)
				{
					$kc_current_time = time();
					$kc_var_time = preg_split('/\/| |:/', $kc_vars[2]);
					$kc_submit_time = gmmktime($kc_var_time[3], $kc_var_time[4], $kc_var_time[5], $kc_var_time[1], $kc_var_time[2], $kc_var_time[0]);
					if (($kc_current_time - $kc_submit_time) < 15)
					{
						return true;
					}
				}
				else
				{
					if ($this->http_get($kc_vars[2]) == "1")
					{
						return true;
					}
				}
			}
			return false;
		}

		function render_js ()
		{
			if ( strlen($this->p_kc_js_code) == 0 )
			{
				return ('<div style="color:#FF0000;">'.JText::_('KEYCAPTCHA_EMPTY_SETTINGS_MESSAGE').'</div>');
			}
			if ( isset($_SERVER['HTTPS']) && ( $_SERVER['HTTPS'] == 'on' ) )
			{
				$this->p_kc_js_code = str_replace ("http://","https://", $this->p_kc_js_code);
			}
			$this->p_kc_js_code = str_replace ("#KC_SESSION_ID#", $this->p_kc_session_id, $this->p_kc_js_code);
			$this->p_kc_js_code = str_replace ("#KC_WSIGN#", $this->get_web_server_sign(1), $this->p_kc_js_code);
			$this->p_kc_js_code = str_replace ("#KC_WSIGN2#", $this->get_web_server_sign(), $this->p_kc_js_code);
			return $this->p_kc_js_code;
		}
	}
}

class plgCaptchaKeyCAPTCHA extends JPlugin
{

	public function __construct($subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	/**
		Joomla 2.5  CAPTCHA API
	*/

	/**
	 * Initialise the captcha
	 *
	 * @param	string	$id	The id of the field.
	 *
	 * @return	Boolean	True on success, false otherwise
	 *
	 * @since  2.5
	 */
	public function onInit($id)
	{
		if ( $this->params->get('keycaptcha_site_private_key','') == '' ) {
			return false;
		}

		return true;
	}

	/**
	 * Gets the challenge HTML
	 *
	 * @return  string  The HTML to be embedded in the form.
	 *
	 * @since  2.5
	 */
	public function onDisplay($name, $id, $class)
	{
		$captchaHtmlBlock = '';
		$task_message = $this->params->get('keycaptcha_custom_task_text');
		$view = JRequest::getVar('view');
		if ( $task_message == '' ) {
			if ( $view == 'register' )
				$task_message = JText::_('KEYCAPTCHA_TASK_REGISTRATION_MESSAGE');
			else 
				$task_message = JText::_('KEYCAPTCHA_TASK_COMMON_MESSAGE');
		}
		if ($this->params->get('KC_AllowKCLink')=='Yes'){
 		    $task_message = "$task_message<a target='_blank' href='https://www.keycaptcha.com/joomla-captcha/' style='margin-left:100px; font-size:8px;float:right;'>Joomla CAPTCHA</a>";
		}

		$kc_code = $this->params->get('keycaptcha_code');
		if ( $kc_code[ strlen( $kc_code ) - 1 ] == "'" ) {
			$kc_code = substr( $kc_code, 0, strlen( $kc_code ) - 1 );
		}
		$submit_ids = 'submit';
		$kc_o = new KeyCAPTCHA_CLASS($this->params->get('keycaptcha_site_private_key'), str_replace( '#BUTTONS#', $submit_ids, $kc_code ) );
		$Ok = true;
		$kc_template = str_replace( '(gt)', '>', str_replace( '(lt)', '<', $this->params->get('keycaptcha_html') ) );		
		if ( strpos( $kc_template, '#keycaptcha#' ) == false ) {
			$kc_template = "<br><div id='keycaptcha_div' style='height:220px; padding:0; margin:0; display:table; border:none;'>#keycaptcha#</div>";
		}
		if ( $kc_template[ strlen( $kc_template ) - 1 ] == "'" ) {
			$kc_template = substr( $kc_template, 0, strlen( $kc_template ) - 1 );
		}
		if ( $task_message[ strlen( $task_message ) - 1 ] == "'" ) {
			$task_message = substr( $task_message, 0, strlen( $task_message ) - 1 );
		}		
		$captchaHtmlBlock = str_replace( '#keycaptcha#', '<table style="padding-top:10px; padding-bottom:10px; border:none; " cellpadding="0" cellspacing="0">
				<tr style="border:none;"><td style="border:none;"><input type="hidden" id="capcode" name="capcode" value="false" />
				'.$task_message.'</td></tr><tr style="border:none;"><td style="border:none;" align="center">'.str_replace( '(gt)', '>', str_replace( '(lt)', '<', $kc_o->render_js() ) ).
				'<noscript><b style="color:red;">'.JText::_('KEYCAPTCHA_NOSCRIPT_MESSAGE').'</b></noscript></td></tr></table>', $kc_template );
		return $captchaHtmlBlock;
	}


	/**
	  * Verify if the user's guess was correct
	  *
	  * @return  True if the answer is correct, false otherwise
	  *
	  * @since  2.5
	  */
	public function onCheckAnswer($code)
	{
		$Ok = false;		
		$kc_o = new KeyCAPTCHA_CLASS($this->params->get('keycaptcha_site_private_key'));
		if ($kc_o->check_result(JRequest::getString('capcode', ''))) {
			$Ok = true;
		}
		return $Ok;
	}
}
?>
